package com.example.main;

import android.app.Service;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.BroadcastReceiver;
import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.database.sqlite.SQLiteDatabase;
import android.os.IBinder;
import android.util.Log;
import android.widget.Toast;


public class BluetoothDiscoverService extends Service {
    public BluetoothDiscoverService() {
    }


    @Override
    public IBinder onBind(Intent intent) {
        // TODO: Return the communication channel to the service.
        throw new UnsupportedOperationException("Not yet implemented");
    }

    @Override
    public int onStartCommand(Intent intent, int flags, int startId) {
        //return super.onStartCommand(intent, flags, startId);
        Toast.makeText(this, "Bluetooth Service started", Toast.LENGTH_LONG).show();
        registerReceiver(breceiver, new IntentFilter(BluetoothDevice.ACTION_FOUND));
        Log.d("<x_x>", "registered receiver..");
        findBluetoothDevices();
        return START_NOT_STICKY;
    }

    public void findBluetoothDevices()
    {
        String strbluetooth="";
        BluetoothAdapter mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
        if(mBluetoothAdapter == null)
        {
            strbluetooth = "Device does not support Bluetooth";
            Toast.makeText(getApplicationContext(), "No BT Adapter",Toast.LENGTH_LONG).show();
            return;
        }
        if(!mBluetoothAdapter.isEnabled())
        {
            stopService(new Intent(getBaseContext(),BluetoothDiscoverService.class));
        }

        IntentFilter ifilter = new IntentFilter();
        ifilter.addAction(BluetoothDevice.ACTION_FOUND);
        ifilter.addAction(BluetoothAdapter.ACTION_DISCOVERY_STARTED);
        ifilter.addAction(BluetoothAdapter.ACTION_DISCOVERY_FINISHED);

        if(mBluetoothAdapter.isDiscovering())
            mBluetoothAdapter.cancelDiscovery();

        mBluetoothAdapter.startDiscovery();
        Toast.makeText(getApplicationContext(), "Discovery started..",Toast.LENGTH_LONG).show();
    }

    public final BroadcastReceiver breceiver = new BroadcastReceiver()
    {
        @Override
        public void onReceive(Context context, Intent intent)
        {
            Log.d("<x_x>", "inside broadcast receiver..");

            String action = intent.getAction();
            Toast.makeText(getApplicationContext(), "Inside receiver: " + intent.getAction(), Toast.LENGTH_SHORT).show();
            Log.d("<x_x>", "inside broadcast receiver.." + intent.getAction());
            if (BluetoothDevice.ACTION_FOUND.equals(action)) {
                BluetoothDevice device = intent.getParcelableExtra(BluetoothDevice.EXTRA_DEVICE);
                if(!device.getName().isEmpty() || !device.getAddress().isEmpty())
                {
                    Log.d("<bluetooth devicename>", device.getName() + "bluetooth devicename" + device.getAddress());
                    System.out.println(device.getName());

                    String deviceName = device.getName();

                    // TODO: match and store current system time in DB

                    MySQLiteHelper helper = new MySQLiteHelper(context);
                    SQLiteDatabase database = helper.getWritableDatabase();

                    ContentValues contentValues = new ContentValues();
                    contentValues.put(MySQLiteHelper.COLUMN_DEVICE_LAST_DISCOVERED, System.currentTimeMillis());
                    if(deviceName!=null && !deviceName.isEmpty()){
                        int numberOfRowsAffected = database.update(MySQLiteHelper.TABLE_BLUETOOTH_DEVICE, contentValues, MySQLiteHelper.COLUMN_DEVICE_TITLE+" = ?", new String[] { deviceName } );
                        Log.d("Audwit","numberOfRowsAffected ===="+numberOfRowsAffected);
                        // TODO: 7/11/2016 I probably need to stop bluetooth service here
                    }

                }
            }
        }
    };

    @Override
    public void onDestroy()
    {
        Toast.makeText(this, "Service stopped", Toast.LENGTH_LONG).show();
        unregisterReceiver(breceiver);
        super.onDestroy();
    }
}
