package com.example.main;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

public class MySQLiteHelper extends SQLiteOpenHelper{
	
	//table name and fields for the groups table
	public static final String TABLE_GROUPS="groups";
	public static final String COLUMN_GROUPID="group_id";
	public static final String COLUMN_GROUPNAME="group_name";
	public static final String COLUMN_GROUPPROB="groupprob";
	public static final String COLUMN_GROUPINTERRUPTIONPREF="interruptionPref";
	public static final String COLUMN_GROUPNONINTERRUPTIONPREF="noninterruptionPref";

	//table name and fields for the group_contacts table
	public static final String TABLE_CONTACTS="contacts";
	public static final String COLUMN_CONTACTSID="contacts_id";
	public static final String COLUMN_CONTACTNAME="contact_name";
	public static final String COLUMN_CONTACTPHONE="contact_phone";
	public static final String COLUMN_CONTACTGROUP="contact_group";
	
	//table name and fields for the TOD_profile table
	public static final String TABLE_TOD_PROFILE="timeOfDay";
	public static final String COLUMN_TODTITLE="tod_title";
	public static final String COLUMN_TODID="tod_id";
	public static final String COLUMN_TODPROB="tod_prob";
	public static final String COLUMN_TODINTERRUPTIONPREF="todInterruptionPref";
	public static final String COLUMN_TODNONINTERRUPTIONPREF="todNonInterruptionPref";
	public static final String COLUMN_STARTTIME="startTime";
	public static final String COLUMN_ENDTIME="endTime";
	public static final String COLUMN_MONDAY="monday";
	public static final String COLUMN_TUESDAY="tuesday";
	public static final String COLUMN_WEDNESDAY="wednesday";
	public static final String COLUMN_THURSDAY="thursday";
	public static final String COLUMN_FRIDAY="friday";
	public static final String COLUMN_SATURDAY="saturday";
	public static final String COLUMN_SUNDAY="sunday";

	//table name and fields for the BLUETOOTH_DEVICE table
	public static final String TABLE_BLUETOOTH_DEVICE="bluetooth_device";
	public static final String COLUMN_DEVICE_TITLE="bluetooth_device_title";
	public static final String COLUMN_DEVICE_ID="bluetooth_device_id";
	public static final String COLUMN_DEVICE_PROB="bluetooth_device_prob";
	public static final String COLUMN_DEVICE_INTERRUPTION_PREF="bluetooth_device_interruption_pref";
	public static final String COLUMN_DEVICE_LAST_DISCOVERED="bluetooth_device_last_discovered";


	// table name matrix table

	public static String TABLE_MATRIX="matrix";
	public static String COLUMN_MATRIX_ID="matrix_id";
	public static String COLUMN_MATRIX_TOD_ID="matrix_tod_id";
	public static String COLUMN_MATRIX_TOD_TITLE="matrix_tod_title";
	public static String COLUMN_MATRIX_GROUP_ID="matrix_group_id";
	public static String COLUMN_MATRIX_GROUP_TITLE="matrix_group_title";
	public static String COLUMN_MATRIX_VALUE="matrix_value";
	public static String COLUMN_MATRIX_UPDATED_TIME="matrix_updated_time";


	//table name and fields for the location table
	public static final String TABLE_LOCATION="location";
	public static final String COLUMN_LOCATIONID="location_id";
	public static final String COLUMN_LOCATIONPROFILE="location_profile";
	public static final String COLUMN_LOCATIONNAME="location_name";
	public static final String COLUMN_LOCATIONPROB="location_prob";
	public static final String COLUMN_LOCATIONINTERRUPTIONPREF="locationInterruptionPref";
	public static final String COLUMN_LOCATIONNONINTERRUPTIONPREF="locationNonInterruptionPref";
	public static final String COLUMN_LOCATIONLAT="locationlat";
	public static final String COLUMN_LOCATIONLONG="locationlong";

	//table name and fields for the feedback table
	public static final String TABLE_FEEDBACK="feedback";
	public static final String COLUMN_FEEDBACKID="feedback_id";
	public static final String COLUMN_FEEDBACK_GROUPID="feedback_group_id";
	public static final String COLUMN_FEEDBACKVAL="feedbackval";

	private static final String DATABASE_NAME = "interruption.db";
	private static final int DATABASE_VERSION = 12;  //what happens if you roll back?


	
	//Creates the groups table
	private static final String DATABASE_GROUPCREATE="create table " + TABLE_GROUPS +"(" + COLUMN_GROUPID
			+ " integer primary key autoincrement, " + COLUMN_GROUPNAME + " text not null," + COLUMN_GROUPPROB + " integer, "
			+ COLUMN_GROUPINTERRUPTIONPREF + " integer, " + COLUMN_GROUPNONINTERRUPTIONPREF + " integer);";
	
	//Creates the contacts table
	private static final String DATABASE_CONTACTSCREATE="create table " + TABLE_CONTACTS + "(" + COLUMN_CONTACTSID + 
			" integer primary key autoincrement, " + COLUMN_CONTACTNAME + " text not null," +  COLUMN_CONTACTPHONE + " text not null," + 
			COLUMN_CONTACTGROUP + " integer, " + "FOREIGN KEY (" + COLUMN_CONTACTGROUP +") REFERENCES " + TABLE_GROUPS + " (" +COLUMN_GROUPID +"));";
	
	//Creates the time of day table
	private static final String DATABASE_TIMEOFDAYCREATE="create table " + TABLE_TOD_PROFILE +"(" + COLUMN_TODID
			+ " integer primary key autoincrement, " + COLUMN_TODTITLE + " text not null," + COLUMN_TODPROB + " integer, "
			+ COLUMN_TODINTERRUPTIONPREF + " integer, " + COLUMN_TODNONINTERRUPTIONPREF + " integer, " + COLUMN_STARTTIME + " integer, " 
			+ COLUMN_ENDTIME + " integer, " + COLUMN_MONDAY + " integer, " + COLUMN_TUESDAY + " integer, " + COLUMN_WEDNESDAY + " integer, "
			+ COLUMN_THURSDAY + " integer, " + COLUMN_FRIDAY + " integer, " + COLUMN_SATURDAY + " integer, " + COLUMN_SUNDAY + " integer);";

	//Creates the location table
	private static final String DATABASE_LOCATIONCREATE="create table " + TABLE_LOCATION +"(" + COLUMN_LOCATIONID
			+ " integer primary key autoincrement, " + COLUMN_LOCATIONPROFILE + " text not null," + COLUMN_LOCATIONNAME + " text, "
			+ COLUMN_LOCATIONPROB + " integer, " + COLUMN_LOCATIONINTERRUPTIONPREF + " integer, " + COLUMN_LOCATIONNONINTERRUPTIONPREF + " integer, " +
					COLUMN_LOCATIONLAT + " real, " + COLUMN_LOCATIONLONG + " real);";

	//************************************************ Matrix table************************************************
	private static final String DATABASE_MATRIXCREATE= "create table " + TABLE_MATRIX +"(" + COLUMN_MATRIX_ID + " integer primary key autoincrement, "
			+ COLUMN_MATRIX_TOD_ID + " integer, " + COLUMN_MATRIX_TOD_TITLE + " text not null," + COLUMN_MATRIX_GROUP_ID + " integer, "
			+ COLUMN_MATRIX_GROUP_TITLE + " text not null, " + COLUMN_MATRIX_VALUE + " text not null, " + COLUMN_MATRIX_UPDATED_TIME + " text not null );" ;

//************************************************ Matrix table************************************************

//************************************************ Feedback table************************************************
private static final String DATABASE_FEEDBACKCREATE= "create table " + TABLE_FEEDBACK +"(" + COLUMN_FEEDBACKID + " integer primary key autoincrement, "
		+ COLUMN_FEEDBACK_GROUPID + " integer, " + COLUMN_FEEDBACKVAL + " integer);" ;

//************************************************ Feedback table************************************************


	//Creates the groups table
	private static final String DATABASE_BLUETOOTH_DEVICE_CREATE="create table " + TABLE_BLUETOOTH_DEVICE +"(" + COLUMN_DEVICE_ID
			+ " integer primary key autoincrement, " + COLUMN_DEVICE_PROB + " integer, "
			+ COLUMN_DEVICE_INTERRUPTION_PREF + " integer, " + COLUMN_DEVICE_TITLE + " text not null, "+COLUMN_DEVICE_LAST_DISCOVERED+" integer );";

public MySQLiteHelper(Context context){
		super(context, DATABASE_NAME, null, DATABASE_VERSION);
	}
	
	@Override
	public void onCreate(SQLiteDatabase database){
		database.execSQL(DATABASE_GROUPCREATE);
		database.execSQL(DATABASE_CONTACTSCREATE);
		database.execSQL(DATABASE_TIMEOFDAYCREATE);
		database.execSQL(DATABASE_LOCATIONCREATE);
		database.execSQL(DATABASE_MATRIXCREATE);
		database.execSQL(DATABASE_FEEDBACKCREATE);
		database.execSQL(DATABASE_BLUETOOTH_DEVICE_CREATE);

	}
	
	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion){
		Log.w(MySQLiteHelper.class.getName(),
		"Upgrading database from version " + oldVersion + " to " + newVersion + ", which will destroy all old date");
		db.execSQL("DROP TABLE IF EXISTS " + TABLE_GROUPS);
		db.execSQL("DROP TABLE IF EXISTS " + TABLE_CONTACTS);
		db.execSQL("DROP TABLE IF EXISTS " + TABLE_TOD_PROFILE);
		db.execSQL("DROP TABLE IF EXISTS " + TABLE_LOCATION);
		db.execSQL("DROP TABLE IF EXISTS " + TABLE_MATRIX);
		db.execSQL("DROP TABLE IF EXISTS " + TABLE_FEEDBACK);
		db.execSQL("DROP TABLE IF EXISTS " + TABLE_BLUETOOTH_DEVICE);

		onCreate(db);
	}
}
